org.codehaus.groovy.transform.stc

## Enum StaticTypesMarker

- java.lang.Object
- - java.lang.Enum<StaticTypesMarker>
  - - org.codehaus.groovy.transform.stc.StaticTypesMarker

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Comparable<StaticTypesMarker>

      public enum StaticTypesMarker
      extends java.lang.Enum<StaticTypesMarker>

  This enumeration is used by the AST transformations which rely on static type checking, either to store or to retrieve information from AST node metadata. The values of this enumeration are used as metadata keys.

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `CLOSURE_ARGUMENTS`
    `DECLARATION_INFERRED_TYPE`
    `DIRECT_METHOD_CALL_TARGET`
    `INFERRED_RETURN_TYPE`
    `INFERRED_TYPE`
    `INITIAL_EXPRESSION`
    `READONLY_PROPERTY`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static StaticTypesMarker` | `valueOf(java.lang.String name)` Returns the enum constant of this type with the specified name.
    `static StaticTypesMarker[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### INFERRED_TYPE

          public static final StaticTypesMarker INFERRED_TYPE

    - #### DECLARATION_INFERRED_TYPE

          public static final StaticTypesMarker DECLARATION_INFERRED_TYPE

    - #### INFERRED_RETURN_TYPE

          public static final StaticTypesMarker INFERRED_RETURN_TYPE

    - #### CLOSURE_ARGUMENTS

          public static final StaticTypesMarker CLOSURE_ARGUMENTS

    - #### READONLY_PROPERTY

          public static final StaticTypesMarker READONLY_PROPERTY

    - #### INITIAL_EXPRESSION

          public static final StaticTypesMarker INITIAL_EXPRESSION

    - #### DIRECT_METHOD_CALL_TARGET

          public static final StaticTypesMarker DIRECT_METHOD_CALL_TARGET

  - ### Method Detail

    - #### values

          public static StaticTypesMarker[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (StaticTypesMarker c : StaticTypesMarker.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static StaticTypesMarker valueOf(java.lang.String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
        `java.lang.NullPointerException` - if the argument is null